<?php

	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

	require_once( dirname(__FILE__) . "/app.php.inc" );
	
	/* ---------------------------------------------------------------
	 * ڡå饹
	 * 饹᥽åɤΤ߻Ѳǽ
	 */
	
	// ڡåΥǥե͡ڡͭḁ̂ڡ꤬ͥ褵롣
	define( 'AD_PAGECACHE_ENABLED', false ); // false : å夷ʤ,  true : å夹
	define( 'AD_PAGECACHE_EXPIRES', '' ); // '' : åͭ¤ʤ,  ':ʬ' : λĶ饭åƺ롣'5:00'
	
	$gADPageCacheEnabled = AD_PAGECACHE_ENABLED;
	function cmsd_set_pagecache_enabled( $enabled )
	{
		global $gADPageCacheEnabled;
		$gADPageCacheEnabled = ( $enabled === true );
	}
	
	function cmsd_get_pagecache_enabled()
	{
		global $gADPageCacheEnabled;
		return $gADPageCacheEnabled;
	}
	
	$gADPageCacheExpires = AD_PAGECACHE_EXPIRES;
	function cmsd_set_pagecache_expires( $expires )
	{
		global $gADPageCacheExpires;
		$gADPageCacheExpires = $expires;
	}
	
	function cmsd_get_pagecache_expires()
	{
		global $gADPageCacheExpires;
		return $gADPageCacheExpires;
	}
	
	function cmsd_pagecache( $param )
	{
		if ( $param === "on" ) 
		{
			cmsd_set_pagecache_enabled( true );
		}
		else if ( $param === "off" ) 
		{
			cmsd_set_pagecache_enabled( false );
		}
		else {
			// H:MΥå
			if ( ! preg_match( '/^\d{1,2}:\d{1,2}$/', $param ) )
			{
				cmsd_abort_proc( "cmsd_pagecache() function must be given 'on'|'off'|H24:M in the parameter." );
			}
			
			// Ȥͤ
			$hour = '';
			$minute = '';
			list( $hour, $minute ) = explode( ':', $param );
			
			$hour = intval( $hour );
			$minute = intval( $minute );
			
			if ( $hour < 0 || $hour > 23 || $minute < 0 || $minute > 59 )
			{
				cmsd_abort_proc( "cmsd_pagecache() : '$param' is not valid time string(H24:M)." );
			}
			
			// Хѿ˳Ǽ
			cmsd_set_pagecache_enabled( true );
			cmsd_set_pagecache_expires( $param );
		}
	
	}
	
	class ADPageCache
	{
		/// 饹᥽åɷ
		function isEnabled()
		{
			return cmsd_get_pagecache_enabled();
		}
		
		// ꥯURL饭åID
		function createCacheIDFromRequest()
		{
			$server_name = $_SERVER['SERVER_NAME'];
			$script_name = $_SERVER['SCRIPT_NAME'];
			$query_string = isset($_SERVER['QUERY_STRING']) ? $_SERVER['QUERY_STRING'] : '';
			
			$cacheID = $server_name . $script_name . $query_string;
			
			// ƬΥå(/)
			//$cacheID = substr( $script_name . $query_string, 1 );
			
			// åIDʬ
			$sessionName = session_name();
			$expstr = '/(&|)' . $sessionName . '=[^&]*/';
			$cacheID = preg_replace( $expstr, "", $cacheID );
			
			// ե̾ȤƻȤʤʸִʥԥꥪɤϡʳĥк
			$cacheID = strtr( $cacheID, '\/:?*"><.', '__________' );
			
			// ץե"pg"Ĥ
			$cacheID = "pg" . $cacheID;
			
			// 250ʸʾʤ顢ʸʤĤޤꡢåʤ
			if ( strlen( $cacheID ) > 250 )
			{
				$cacheID = "";
			}
			
			return $cacheID;
		}
		
		// åǡ¸ߥå
		function exists( $cacheID )
		{
			// åIDʸξ硢åʤ
			if ( $cacheID == "" ) return false;
			// ե¸ߥå
			return file_exists( ADPageCache::getCacheFilePath( $cacheID ) );
		}
		
		// åǡΥեѥ
		function getCacheFilePath( $cacheID )
		{
			return App::getCacheDir() . "pagecache/" . $cacheID;
		}
		
		// åǡɸϤؽϤ
		function outputCache( $cacheID )
		{
			$filename = ADPageCache::getCacheFilePath( $cacheID );
		
			$fp = fopen( $filename, 'rb');
			flock( $fp, LOCK_SH );	// ɤ߹ߥåʶͭå
			while (!feof($fp))
			{
				echo fread($fp, 4096);
			}
			flush();
			@flock( $fp, LOCK_UN );
			fclose($fp);
		
			//readfile( ADPageCache::getCacheFilePath( $cacheID ) );
		}
		
		// åǡ¸ߤϾ񤭤
		function createCache( $cacheID, $pagedata )
		{
			if ( $cacheID != "" )
			{
				$filename = ADPageCache::getCacheFilePath( $cacheID );
				$fp = @fopen( $filename, 'w' );
				if ( $fp )
				{
					// 񤭹ߥå˼Ԥ饭åʤå夬ʤ̵Ǻ
					if ( ! ADPageCache::exists( $cacheID ) || flock( $fp, LOCK_EX ) )	
					{
						@fwrite( $fp, $pagedata );
						flock( $fp, LOCK_UN );
					}
					
					@fclose( $fp );
					@chmod( $filename, 0666 );
				}
			}
		}
		
		/*
		// åǡ¸ߤʤΤߡåǡ롣
		function createCacheIfNoCache( $cacheID, $pagedata )
		{
			if ( ! ADPageCache::exists( $cacheID ) )
			{
				ADPageCache::createCache( $cacheID, $pagedata );
			}
		}
		*/
		
		// åե
		function deleteAllCaches()
		{
			$pageCacheFilePath = App::getCacheDir() . "pagecache/*";
			$files = glob( $pageCacheFilePath );
			if ( $files )
			{
				foreach( $files as $filename )
				{
					unlink( $filename );
				}
			}
		}
		
		// å夬ͭڤ줫ͭڤʤtrue֤
		function isExpired( $cacheID )	// $expires = '7:30'
		{
			// ͽ郎ꤵƤʤСͭڤʤ
			$expires = cmsd_get_pagecache_expires();
			if ( $expires === "" )
			{
				return false;	
			}
			
			// åե뤬¸ߤʤСͭڤ֤
			if ( ! ADPageCache::exists( $cacheID ) )
			{
				return true;
			}
		
			// åեκ
			$timeOfCache = filemtime( ADPageCache::getCacheFilePath( $cacheID ) );
			
			// 
			$timeOfNow = time();
			
			// եηв
			$timeDiffPast = $timeOfNow - $timeOfCache;
			
			// ͽʥˤ饿ॹפդϸߤΤΤѡ
			$updateHour = '';
			$updateMinute = '';
			
			
			list( $updateHour, $updateMinute ) = explode( ':', $expires );
			$timeOfUpdate = mktime( $updateHour, $updateMinute );
			
			// ե狼鹹ͽޤǤͱͽ
			$timeDiffRemain = (( $timeOfUpdate + 60 * 60 * 24 ) - $timeOfCache ) % ( 60 * 60 * 24 );
			
			if ( $timeDiffPast > $timeDiffRemain )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		
	}
?>