<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

    require_once( dirname(__FILE__) . "/app.php.inc" );

    /* --------------------------------------------------------------------
     * եϹܴܥ饹
     * 
     */ 
	class BaseEntryItem
	{
    	var $dataName = '';
    	var $dataType = '';
    	var $dataCaption = '';
		var $dataDescription = '';
		
		var $entryName = '';
		var $entryId = '';
    	
    	var $errorMessage = '';

		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $xmlSchemaData : б륹DataXMLǡ
		 */
    	function BaseEntryItem( $xmlSchemaData, $entryName, $entryId )
    	{
    		$this->dataName = $xmlSchemaData->get_attribute('name');
    		$this->dataType = $xmlSchemaData->get_attribute('type');
    		$this->dataCaption =  file2code( $xmlSchemaData->get_attribute('caption') );
			$this->dataDescription = file2code( $xmlSchemaData->get_attribute('description') );
			
			
			$this->entryName = $entryName;
			$this->entryId = $entryId;
			
			// å
			if ( empty( $this->dataName ) )
			{
				cmsd_abort_proc( "޹顼'name'°ޤ" );
			}
			
			if ( empty( $this->dataType ) )
			{
				cmsd_abort_proc( "޹顼'" . $this->dataName .  "'type°ޤ" );
			}

			if ( empty( $this->dataCaption ) )
			{
				cmsd_abort_proc( "޹顼'" . $this->dataName .  "'caption°ޤ" );
			}

						
    	}
    	
		/* ----------------------------------------------------------------
		 * 顼åμ
		 */
    	function getErrorMessage()
    	{
    		return $this->errorMessage;
    	}
    	

		/* ----------------------------------------------------------------
		 * ܤXMLΡɤ򿷵롣
		 * $xmlDocParentEntry : ȥDOM֥ȡ
		 * return : XMLΡɡ
		 */
    	function createNew( $xmlDocParentEntry )
    	{
			$newNode = $xmlDocParentEntry->create_element( $this->dataName );
    		return $newNode;
    	}
		
		/* ----------------------------------------------------------------
		 * ܤΥǡ֤̾
		 * return : ǡ̾
		 */
		function getName()
		{
			return $this->dataName;
		}
		
		/* ----------------------------------------------------------------
		 * ܤΥǡ֤̾
		 * return : ǡ̾
		 */
		function getType()
		{
			return $this->dataType;
		}
    	
	}
	




?>